# calendar.pl 2000/07/02 ver.1.0 by  mm

$Monday = 1;	# ˳Ϥ0
%F = (
	'Table',			"<table cellpadding=0 cellspacing=0 class='doc131' border=0>",
	'Header',			"<tr><th colspan=7><#Year>/<#Month></th></tr>",
	'Body',				"<tr align='center'><#SevenCells></tr>",
	'Cell(Noday)',		'<td>&nbsp;</td>',
	'Cell',				'<td><#Date><#Data></td>',
	'Date(Sunday)',		"<font color='red'><#Day></font>",
	'Date(Saturday)',	"<font color='blue'><#Day></font>",
	'Date',				"<#Day>",
	'Day(Today)',		'<b><u><#day></u></b>',
	'Day',				'<#day>',
	'Footer',			'</table>');
($ToDay,$ThisMonth,$ThisYear) = (localtime)[3..5];
++$ThisMonth; $ThisYear += 1900;
@LastDay = (0,31,29,31,30,31,30,31,31,30,31,30,31);

# ------------
sub printCalendar {
	local($d,$m) = @_;
	local($year,$month) = ($ThisYear,$ThisMonth);
	if ($m eq ''){
		if ($d > 0){
			while ($d--){
				if (++$month > 12){++$year; $month = 1;}
			}
		}
		elsif ($d < 0){
			while ($d++) {
				if (--$month < 1){--$year; $month = 12;}
			}
		}
		else {}
	}
	&printHeader($year,$month);
	&printBody($year,$month);
	print $F{'Footer'};
}
# ------------
sub printHeader {
	local($year,$month) = @_;
	local($w) = ' width=17';
	local($Header) = $F{'Header'};
	$Header =~ s|<#Month>|$month|g;
	$Header =~ s|<#Year>|$year|g;
	print $F{'Table'};
	print "<tr><td$w height=6></td><td$w></td><td$w></td><td$w></td><td$w></td><td$w></td><td$w></td>";
	print $Header;
}
# ------------
sub printBody {
	local($year,$month) = @_;
	local($today) = (0);
	if ($year == $ThisYear && $month == $ThisMonth){$today = $ToDay;}
	local(@lastday) = &setLastDay($year);	# ǯθ
	local($y,$m,$day) = ($year,$month,1);	# Zellerθ
	if ($m < 3){--$y; $m+=12;}
	$day = ($y+int($y/4)-int($y/100)+int($y/400)+int((13*$m+8)/5)+$day) % 7;
	if ($Monday){$day = 6 if --$day < 0;}
	$day = 1 - $day;
	&printWeek($year,$month,$day,$lastday[$month],$today );
	&printWeek($year,$month,$day+=7,$lastday[$month],$today);
	&printWeek($year,$month,$day+=7,$lastday[$month],$today);
	&printWeek($year,$month,$day+=7,$lastday[$month],$today);
	&printWeek($year,$month,$day+=7,$lastday[$month],$today);
	if ($day+7 <= $lastday[$month]) {
		&printWeek($year,$month,$day+=7,$lastday[$month],$today);
	}
}
# ------------
sub printWeek {
	local($year,$month,$day,$lastday,$today) = @_;
	local($wday);
	local($ymd,$md);
	local($Body,$SevenCells,$Cell,$Date,$Day,$Data);
	if ($Monday >= 1){$Saturday = 5; $Sunday = 6;}
	else {$Saturday = 6; $Sunday = 0;}
	for ($wday = 0; $wday < 7; $wday++, $day++){
		if ($day < 1 || $lastday < $day){
			$Cell = $F{'Cell(Noday)'};
		}
		else {
			$md = "$month/$day";
			$ymd = "$year/$md";
			$Day = ($day==$today)? $F{'Day(Today)'} : $F{'Day'};
			$Day =~ s|<#day>|$day|g;
			if ($wday == $Sunday){
				$Date = $F{'Date(Sunday)'};
			}
			elsif($wday == $Saturday){
				$Date = $F{'Date(Saturday)'};
			}
			else {
				$Date = $F{'Date'};
			}
			$Date =~ s|<#Day>|$Day|g;
			$Cell = $F{'Cell'};
			$Cell =~ s|<#Date>|$Date|g;
			$Cell =~ s|<#Data>|$Data|g;
		}
		$SevenCells .= $Cell;
	}
	$Body = $F{'Body'};
	$Body =~ s|<#SevenCells>|$SevenCells|g;
	print $Body;
}
# ------------
sub setLastDay {
	local($y) = @_;
	local(@d) = @LastDay;
	--$d[2] if ($y%4!=0 || ($y%100==0 && $y%400!=0));
	@d;
}
1;
